unit Unit1;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, Forms, Controls, Graphics, Dialogs, StdCtrls, ComCtrls,
  TAGraph, TASources, TAIntervalSources, TASeries, TATools, Types, TATypes, TACustomSeries, TADrawUtils;

type

  { TForm1 }

  TForm1 = class(TForm)
    Chart1: TChart;
    Chart1LineSeries1: TLineSeries;
    ChartToolset1: TChartToolset;
    ChartToolset1DataPointClickTool1: TDataPointClickTool;
    ChartToolset1UserDefinedTool1: TUserDefinedTool;
    DateTimeIntervalChartSource1: TDateTimeIntervalChartSource;
    Memo1: TMemo;
    RandomChartSource1: TRandomChartSource;
    StatusBar1: TStatusBar;
    procedure Chart1LineSeries1CustomDrawPointer(ASender: TChartSeries;
      ADrawer: IChartDrawer; AIndex: Integer; ACenter: TPoint);
    procedure ChartToolset1DataPointClickTool1PointClick(ATool: TChartTool;
      APoint: TPoint);
    procedure ChartToolset1UserDefinedTool1AfterMouseDown(ATool: TChartTool;
      APoint: TPoint);
    procedure FormCreate(Sender: TObject);
    procedure FormKeyDown(Sender: TObject; var Key: Word; Shift: TShiftState);
  private
    FCurrSeries: TChartSeries;
    FCurrIndex: Integer;
    procedure UpdateSelectedPoint(ASeries: TChartSeries; AIndex: Integer);

  public

  end;

var
  Form1: TForm1;

implementation

{$R *.lfm}

uses
  LCLType, Math;

{ TForm1 }

procedure TForm1.Chart1LineSeries1CustomDrawPointer(ASender: TChartSeries;
  ADrawer: IChartDrawer; AIndex: Integer; ACenter: TPoint);
const
  DELTA: Integer = 128;
var
  r: Integer;
  lineser: TLineSeries;
  c: TColor;
begin
  lineser := ASender as TLineSeries;
  ADrawer.SetBrush(lineser.Pointer.Brush);
  ADrawer.SetPen(lineser.Pointer.Pen);
  if (ASender = FCurrSeries) and (AIndex = FCurrIndex) then
  begin
    r := lineSer.Pointer.HorizSize * 2;
    c := lineSer.Pointer.Brush.Color;
    c := RGBToColor(
      Min(255, DELTA + Red(c)),
      Min(255, DELTA + Green(c)),
      Min(255, DELTA + Blue(c))
    );
    ADrawer.BrushColor := c;
    ADrawer.Ellipse(ACenter.X - r, ACenter.Y - r, ACenter.X + r, ACenter.Y + r);
  end else
    lineser.Pointer.Draw(ADrawer, ACenter, clDefault, true);
end;

procedure TForm1.ChartToolset1DataPointClickTool1PointClick(ATool: TChartTool;
  APoint: TPoint);
var
  tool: TDatapointClickTool;
begin
  tool := TDatapointClickTool(ATool);
  if tool.Series = nil then
    UpdateSelectedPoint(nil, -1)
  else
    UpdateSelectedPoint(TChartSeries(tool.Series), tool.PointIndex);
end;

procedure TForm1.ChartToolset1UserDefinedTool1AfterMouseDown(ATool: TChartTool;
  APoint: TPoint);
begin
  UpdateSelectedPoint(nil, -1);
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
  FCurrIndex := -1;
end;

procedure TForm1.FormKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
var
  x, y: Double;
begin
  if (FCurrIndex > -1) then begin
    Chart1.SetFocus;
    case Key of
      VK_LEFT, VK_UP :
        if FCurrIndex > 0 then
          UpdateSelectedPoint(FCurrSeries, FCurrIndex - 1);
      VK_RIGHT, VK_DOWN:
        if FCurrIndex < FCurrSeries.Count - 1 then
          UpdateSelectedPoint(FCurrSeries, FCurrIndex + 1);
      VK_RETURN:
        begin
          x := FCurrSeries.XValue[FCurrIndex];
          y := FCurrSeries.YValue[FCurrIndex];
          Memo1.Lines.Add(Format('%s: %f', [DateToStr(x), y]));
          if Memo1.Lines[Memo1.Lines.Count-1] = '' then
            Memo1.Lines.Delete(Memo1.Lines.Count-1);
        end;
    end;
  end;
end;

procedure TForm1.UpdateSelectedPoint(ASeries: TChartSeries; AIndex: Integer);
begin
  FCurrSeries := ASeries;
  FCurrIndex := AIndex;
  Chart1.Invalidate;
end;

end.

